<!DOCTYPE html>
<html>
<head>
  <meta charset="UTF-8">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
</head>
<body>
  <div class="container mt-4">
    <h2>Lucky Dice History</h2>
      <div class="form-group">
        <label for="username">User name:</label>
        <input type="email" class="form-control" id="inp-username" placeholder="Enter username" name="username">
      </div>
      <div class="form-group">
        <button type="button" class="btn btn-primary" onclick="onBtnShowDiceHistoryClick()">Show Dice History Table</button>
      </div>
    <div id="log-result" class="mt-5"></div>
    <div class="mt-5">
      <table id="table-dice-history" class="table table-striped table-bordered table-hover">
        <thead>
          <tr>
            <th>Game</th>
            <th>Dice</th>
          </tr>
        </thead>
        <tbody id="body-dice-history">         
        </tbody>
      </table>
    </div>
  </div>

  <script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gEND_OF_ROW_COL = -1;
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //Hàm xử lý sự kiện click nút show dice history
    function onBtnShowDiceHistoryClick() {
      //B0: khai báo đối tượng dữ liệu
      var vUserObject = {
        username:""
      }
      //B1: thu thập dữ liệu
      getUserData(vUserObject);

      //B2: kiểm tra dữ liệu
      var valid = validateUserData(vUserObject);

      if (valid) {
        //B3: call api 
        var vXmlHttpDiceHistory = new XMLHttpRequest();
        callApiDiceHistory(vXmlHttpDiceHistory, vUserObject);

        vXmlHttpDiceHistory.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                  //B4: hiển thị kết quả
                  displayDiceHistoryData(vXmlHttpDiceHistory.responseText);
                }
            }
        
      }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //Hàm thu thập dữ liệu trên form
    function getUserData(paramUserObject) {
      var vInputUsername = document.getElementById("inp-username");
      paramUserObject.username = vInputUsername.value.trim();
    }

    //Hàm kiểm tra dữ liệu trên form
    function validateUserData(paramUserObject) {
      if (paramUserObject.username == "") {
        alert("Phải nhập vào username");
        return false;
      }

      return true;
    }

    //Hàm call api dice history
    function callApiDiceHistory(paramXmlHttpDiceHistory, paramUserObject) {
        "use strict";
        paramXmlHttpDiceHistory.open("GET", gBASE_URL + "/dice-history?username=" + paramUserObject.username, true);
        paramXmlHttpDiceHistory.send();
    }

    //Hàm hiển thị kết quả call api
    function displayDiceHistoryData(paramResponseText) {
      console.log(paramResponseText);
      var vDiceHistoryObjects = JSON.parse(paramResponseText);
      console.log(vDiceHistoryObjects);

      //Hiển thị dữ liệu lên table
      /*
      //C1: tạo html cho table
      var vHtml = '';
      for (var bIndex = 0; bIndex < vDiceHistoryObjects.dices.length; bIndex++) {
        vHtml += `<tr>
            <td>${bIndex+1}</td>
            <td>${vDiceHistoryObjects.dices[bIndex]}</td>
          </tr>`;
      }

      //var vBodyDiceHistory = document.getElementById("body-dice-history");
      var vBodyDiceHistory = document.getElementsByTagName("tbody")[0];
      vBodyDiceHistory.innerHTML = vHtml;*/

      //C2: tạo các row, cell theo mô hình dom
      var vBodyDiceHistory = document.getElementById("body-dice-history");
      for (var bIndex = 0; bIndex < vDiceHistoryObjects.dices.length; bIndex++) {
        var newRow = vBodyDiceHistory.insertRow(gEND_OF_ROW_COL);
        var newCol1 = newRow.insertCell(0);
        newCol1.innerHTML = bIndex + 1;

        /*
        var newCol2 = newRow.insertCell(1);
        newCol2.innerHTML = vDiceHistoryObjects.dices[bIndex];*/
        var newCol2 = document.createElement("td");
        newCol2.innerHTML = vDiceHistoryObjects.dices[bIndex];
        newRow.appendChild(newCol2);        
      }
    }
  </script>


</body>

</html>